<?php
namespace ElementorPro\Modules\Forms\Fields;

use Elementor\Controls_Manager;
use ElementorPro\Plugin;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

class Date extends Field_Base {
	public $depended_scripts = ['pDate', 'pDatepicker', 'pDatepickerLoader'
	];

	public $depended_styles = ['pDate-style'
	];

	public function get_name() {
		return esc_html__( 'Date', 'elementor-pro' );
	}

	public function render( $item, $item_index, $form ) {
		if ( isset( $item['shamsi_date'] ) && 'yes' === $item['shamsi_date'] ) {
            $required = '';
            if ($item['required']){
                $required = " required='required'";
            }
            $min = '';
			if ( ! empty( $item['min_date'] ) ) {
                $min = " min='{$item['min_date']}'";
			}
            $max = '';
			if ( ! empty( $item['max_date'] ) ) {
				$form->add_render_attribute( 'input' . $item_index, 'max', esc_attr( $item['max_date'] ) );
				$max = " max='{$item['max_date']}'";
			}
            echo "
            <input type='text' name='form_fields[{$item['custom_id']}]'$required $min $max id='form-field-{$item['custom_id']}' class='elementor-field elementor-field-textual elementor-persian-date active' pattern='[۰-۹0-9]{4}-[۰-۹0-9]{2}-[۰-۹0-9]{2}'>
            ";
			return;
		}
		$form->add_render_attribute( 'input' . $item_index, 'class', 'elementor-field-textual elementor-date-field' );
		$form->add_render_attribute( 'input' . $item_index, 'pattern', '[0-9]{4}-[0-9]{2}-[0-9]{2}' );
		if ( isset( $item['use_native_date'] ) && 'yes' === $item['use_native_date'] ) {
			$form->add_render_attribute( 'input' . $item_index, 'class', 'elementor-use-native' );
		}

		if ( ! empty( $item['min_date'] ) ) {
			$form->add_render_attribute( 'input' . $item_index, 'min', esc_attr( $item['min_date'] ) );
		}

		if ( ! empty( $item['max_date'] ) ) {
			$form->add_render_attribute( 'input' . $item_index, 'max', esc_attr( $item['max_date'] ) );
		}
		?>

		<input <?php $form->print_render_attribute_string( 'input' . $item_index ); ?>>
		<?php
	}

	public function update_controls( $widget ) {
		$elementor = Plugin::elementor();

		$control_data = $elementor->controls_manager->get_control_from_stack( $widget->get_unique_name(), 'form_fields' );

		if ( is_wp_error( $control_data ) ) {
			return;
		}

		$field_controls = [
			'min_date' => [
				'name' => 'min_date',
				'label' => esc_html__( 'Min. Date', 'elementor-pro' ),
				'type' => Controls_Manager::DATE_TIME,
				'condition' => [
					'field_type' => $this->get_type(),
				],
				'label_block' => false,
				'picker_options' => [
					'enableTime' => false,
				],
				'tab' => 'content',
				'inner_tab' => 'form_fields_content_tab',
				'tabs_wrapper' => 'form_fields_tabs',
			],
			'max_date' => [
				'name' => 'max_date',
				'label' => esc_html__( 'Max. Date', 'elementor-pro' ),
				'type' => Controls_Manager::DATE_TIME,
				'condition' => [
					'field_type' => $this->get_type(),
				],
				'label_block' => false,
				'picker_options' => [
					'enableTime' => false,
				],
				'tab' => 'content',
				'inner_tab' => 'form_fields_content_tab',
				'tabs_wrapper' => 'form_fields_tabs',
			],
			'use_native_date' => [
				'name' => 'use_native_date',
				'label' => esc_html__( 'Native HTML5', 'elementor-pro' ),
				'type' => Controls_Manager::SWITCHER,
				'condition' => [
					'field_type' => $this->get_type(),
				],
				'tab' => 'content',
				'inner_tab' => 'form_fields_content_tab',
				'tabs_wrapper' => 'form_fields_tabs',
			],
			'shamsi_date'     => [
				'name'         => 'shamsi_date',
				'label'        => esc_html__( 'تاریخ شمسی', 'elementor-pro' ),
				'type'         => Controls_Manager::SWITCHER,
				'condition'    => [
					'field_type' => $this->get_type(),
				],
				'tab'          => 'content',
				'inner_tab'    => 'form_fields_content_tab',
				'tabs_wrapper' => 'form_fields_tabs',
			]
		];
		// Get the current Elementor document instance
		$value = get_option( 'my_custom_elementor_checkbox' );
		if ( strlen($value) >= 1 ) {
			unset( $field_controls['shamsi_date'] );
		}

		foreach ( $control_data['fields'] as $index => $field ) {
			if ( 'placeholder' !== $field['name'] ) {
				continue;
			}
			foreach ( $field['conditions']['terms'] as $condition_index => $terms ) {
				if ( ! isset( $terms['name'] ) || 'field_type' !== $terms['name'] || ! isset( $terms['operator'] ) || 'in' !== $terms['operator'] ) {
					continue;
				}
				$control_data['fields'][ $index ]['conditions']['terms'][ $condition_index ]['value'][] = $this->get_type();
				break;
			}
			break;
		}

		$control_data['fields'] = $this->inject_field_controls( $control_data['fields'], $field_controls );
		$widget->update_control( 'form_fields', $control_data );
	}

	public function get_type() {
		return 'date';
	}
}
